package checkAlign;


public class PostScript2 {
	// document parameters
	private final int marginX = 50;
	private final int marginY = 50;
	private final int lettersPerLine = 40;
	private final int height = 800;
	private final int width = 500;
	private final int blockHeight = 100;	
	private final char[] letter4 = {'A','C','G','T'};
	private final char[] letter5 = {'A','C','G','T','-'};
	private final char[] letter20 = {'A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y'};
	private final char[] letter21 = {'A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y','-'};
	
	private char[] letterActive;
	private String result = "";
	private Symbol[] column;
		
	PostScript2(){}
	
	void createFile(double[][] matrix, int method, double hg, double sd, int ratio, int initialIndex, int finalIndex){
	    int numLetters = matrix.length;
	    int longSeq = matrix[0].length;
	    int drawnColumnCounter = 0;
	    boolean firstWhite = true;	    
	    String colorActual = "0 0 0";
	    Symbol[] columna = new Symbol[numLetters];
	    StringBuffer sb = new StringBuffer();
	    	    	    
		if (matrix == null){			
			System.out.println("No matrix passed");
			System.exit(0);
		}
		
		
		sb.append("%!PS-Adobe-3.1\n");
		sb.append("\n% ***********   procedures    ***********\n" +
				  "/charPrint{\n" +
				  "gsave\n" +
				  "scale\n" +
				  "0 0 moveto\n" +
				  "setrgbcolor\n" +
				  "show\n" +
				  "grestore\n" +
				  "}def\n\n" +
				  "/drawAxis{\n" +
				  "newpath\n" +
				  "0 0 moveto\n" +
				  "0 0 0 setrgbcolor\n" +
				  "0 100 rlineto\n" +
				  "-4 0 rlineto\n" +
				  "4 0 rmoveto\n" +
				  "0 -100 rmoveto\n" +
				  "%480 0 rlineto\n" +
				  "stroke\n" +
				  "closepath\n" +
				  "0 0 moveto\n" +
				  "0 25 rmoveto\n" +
				  "-4 0 rlineto\n" +
				  "4 0 rmoveto\n" +
				  "0 25 rmoveto\n" +
				  "-4 0 rlineto\n" +
				  "4 0 rmoveto\n" +
				  "0 25 rmoveto\n" +
				  "-4 0 rlineto\n" +
				  "4 0 rmoveto\n" +
				  "stroke\n" +
				  "0 0 moveto\n" +				  
				  "gsave\n" +
				  "/Arial findfont  [9 0 0 9 0 0] makefont\n" +
				  "setfont\n" +
				  "-20 92 moveto\n" +
				  "("+hg+") show\n" +
				  "90 rotate\n" +
				  "40 10 moveto\n" +
				  "(bits) show\n");
		sb.append("grestore\n" +
				  "}def\n\n");
		sb.append("/posPrint{\n" +
				"gsave\n" +
				"/Arial findfont  [9 0 0 9 0 0] makefont\n" +
				"setfont\n" +
			  	"0 0 moveto\n" +
				"90 rotate\n" +
				"-6 -10 rmoveto\n" +
				"show\n" +
				"grestore\n" +
				"}def\n\n");
		sb.append("/drawSd{\n" + 
				"gsave\n" +
				"3 0 moveto\n" + 
				"4 0 rmoveto\n" + 
				"%up\n" + 
				"0 "+sd+" rlineto\n" + 
				"-2 0 rmoveto\n" + 
				"4 0 rlineto\n" + 
				"-2 -"+sd+" rmoveto\n" + 
				"%down\n" + 
				"0 -"+sd+" rlineto\n" + 
				"-2 0 rmoveto\n" + 
				"4 0 rlineto\n" + 
				"stroke\n" + 
				"grestore\n" + 
				"}def\n\n");
		sb.append("/drawBase{\n" +
				"0 0 moveto\n" +
				"12 0 rlineto\n" +
				"stroke\n" +
				"}def\n\n");
		sb.append("% body\n" +
				"60 640 translate\n" +
				"/Arial-BoldMT findfont [100 0 0 137 0 0] makefont\n" +
				"setfont\n" +
				"drawAxis\n");
		
		
		// *****************  loops
		
		// for each position
		for (int pos=initialIndex; pos < finalIndex; pos++){
			if (drawnColumnCounter % lettersPerLine == 0 && drawnColumnCounter != 0){
				sb.append("-480 "+"-130"+" translate\n");
				sb.append("drawAxis\n");
				drawnColumnCounter = 0;				
			}
			// for each column
			for (int letter=0; letter < numLetters; letter++){
				columna[letter] = new Symbol(letter, matrix[letter][pos]);
			}
			columna = sortColumn(columna);
			
			int sumHeight = 0;
			String widthLetter = " 0.2 ";	
			double heightValue = 0;
			int paddingRight = 0;
			int paddingTop = 0;
			int counter = 0;
						
			for (int i=0; i<columna.length; i++){
				if (i == 0) sb.append("drawBase\n");
				colorActual = getColor(numLetters, columna[i].getLetter());
				heightValue = columna[i].getValue();
				
				paddingRight = 0;
				widthLetter = " 0.2 ";
				paddingTop = 0;		
				
				switch(letterActive[columna[i].getLetter()]){
					case 'C': widthLetter = " 0.18 "; heightValue = roundDecimals(heightValue * 0.96, 2); paddingTop = getPaddingTop(heightValue); break;
					case 'D': widthLetter = " 0.18 "; break;
					case 'G': widthLetter = " 0.18 "; heightValue = roundDecimals(heightValue * 0.96, 2); paddingTop = getPaddingTop(heightValue); break;
					case 'I': widthLetter = " 0.4 "; paddingRight = 1; break;
					case 'M': widthLetter = " 0.18 "; break;
					case 'Q': widthLetter = " 0.18 "; heightValue = roundDecimals(heightValue * 0.96, 2); paddingTop = getPaddingTop(heightValue); break;
					case 'S': widthLetter = " 0.18 "; paddingRight = 1; heightValue = roundDecimals(heightValue * 0.96, 2); paddingTop = getPaddingTop(heightValue); break;
					case 'T': widthLetter = " 0.18 "; paddingRight = 2; break;
					case 'V': widthLetter = " 0.18 "; paddingRight = 2; break;
					case 'W': widthLetter = " 0.16 "; break;
					default : widthLetter = " 0.2 "; paddingRight = 0; break; //paddingTop = 0; break;
				}
								
				if (heightValue >= 0.01 && letterActive[columna[i].getLetter()] != '-'){				
					if (paddingRight != 0){
						sb.append(paddingRight + " 0 translate\n");
					}
					if (paddingTop != 0){
						sb.append("0 "+ paddingTop + " translate\n");
					}
					
					if (method == 1){						
				        sb.append("("+letterActive[columna[i].getLetter()]+") " + colorActual + widthLetter + heightValue + " charPrint\n");
						sb.append("0 "+Math.round(heightValue * (double)100)+" translate\n");
						sumHeight += Math.round(heightValue * (double)100);			
						counter++;
				    }else if (method == 2){
				        if (columna[i].getValue() >= (double)ratio / (double)100){
				        	sb.append("("+letterActive[columna[i].getLetter()]+") " + colorActual + widthLetter + heightValue + " charPrint\n");
							sb.append("0 "+Math.round((double)heightValue * (double)100)+" translate\n");
							sumHeight += Math.round((double)heightValue * (double)100);
							counter++;
				        }
				    }
				    
					if (paddingRight != 0){
						sb.append("-" + paddingRight + " 0 translate\n");
					}
					if (paddingTop != 0){
						sumHeight += paddingTop;
					}
				}
			}
			
			if (counter > 0){
				// draw stdev bars
				if (sd != 0){
					sb.append("drawSd\n");
				}
				
				// print pos number
				int posValue = pos+1;
				String posText = String.valueOf(posValue);
				
				int padPos = 0;
				if (posValue < 10) padPos = 4;
				else if (posValue < 100) padPos = 9;
				else if (posValue < 1000) padPos = 14;
				else padPos = 19;
				
				sb.append("0 -"+(sumHeight)+" translate\n"); // return to y=0				
				sb.append("0 -"+padPos+" translate\n"); // down to write pos number
				sb.append("("+posText+") posPrint\n");
				sb.append("12 "+padPos+" translate\n"); // go to next column
			    drawnColumnCounter++;
			    firstWhite = true;
			}else{
				if (firstWhite){
					sb.append("0 -12 translate\n");
					sb.append("( *) posPrint\n");
					sb.append("12 12 translate\n");
					drawnColumnCounter++;
					firstWhite = false;
				}				
			}
		}		
		// *****************  end loops

		
		sb.append("\nshowpage");
		result = sb.toString();
	}
	
	String getFileText(){
		return result;
	}

	void showMatrix(double[][] freqMatrix){
    	int numLetters = freqMatrix.length;
    	int longSeq = freqMatrix[0].length;
    	for (int i=0; i<numLetters; i++){
    		System.out.print(i+": ");
    		for (int j=0; j<longSeq; j++){
    			System.out.print(freqMatrix[i][j]);
    		}
    		System.out.print("\n");
    	}
    }
	private String getColor(int numLetters, int num){
	    // colors
		String colorOrange = "1 0.5 0";
		String colorBlack = "0 0 0";
		String colorRed = "1 0 0";
		String colorYellow = "0.8 0.8 0";
		String colorPink = "1 0 1";
		String colorGray = "0.3 0.3 0.3";
		String colorBlue = "0 0 1";
		String colorActual = colorBlack;
		
	    if (numLetters == 4){
	        letterActive = letter4;
	    }else if (numLetters == 5){
	        letterActive = letter5;
	    }else if (numLetters == 20){
	        letterActive = letter20;
	    }else if (numLetters == 21){
	        letterActive = letter21;
	    }
	    
	    if (numLetters == 4 || numLetters == 5){
	    	switch(num){
		    	case 0:  colorActual = colorBlack; break;
				case 1:  colorActual = colorRed; break;
				case 2:  colorActual = colorBlack; break;
				case 3:  colorActual = colorRed; break;
				default: colorActual = colorBlack; break;
	    	}		    
	    }else{
	    	switch(num){
	    		case 0:  colorActual = colorBlack; break;
	    		case 1:  colorActual = colorBlue; break;
	    		case 2:  colorActual = colorOrange; break;
	    		case 3:  colorActual = colorOrange; break;
	    		case 4:  colorActual = colorBlack; break;
	    		case 5:  colorActual = colorGray; break;
	    		case 6:  colorActual = colorRed; break;
	    		case 7:  colorActual = colorBlack; break;
	    		case 8:  colorActual = colorRed; break;
	    		case 9:  colorActual = colorBlack; break;
	    		case 10:  colorActual = colorBlack; break;
	    		case 11:  colorActual = colorYellow; break;
	    		case 12:  colorActual = colorGray; break;
	    		case 13:  colorActual = colorYellow; break;
	    		case 14:  colorActual = colorRed; break;
	    		case 15:  colorActual = colorPink; break;
	    		case 16:  colorActual = colorPink; break;
	    		case 17:  colorActual = colorBlack; break;
	    		case 18:  colorActual = colorBlack; break;
	    		case 19:  colorActual = colorBlack; break;
	    		default: colorActual = colorBlack; break;
	    	}
	    }
		
	    return colorActual;
	}
	private Symbol[] sortColumn(Symbol[] column){
		int n = column.length;
		for (int i=1; i < n; i++){
			for (int j=0; j < n-i; j++){
				 if (column[j].getValue() > column[j+1].getValue()) {
	                Symbol temp = column[j];
	                column[j] = column[j+1];
	                column[j+1] = temp;
	            }
			}
		}
		
		return column;
	}
	private double roundDecimals(double num, int decimals){
    	//double res = ((int)(num*(Math.pow(10,decimals)))) / Math.pow(10,decimals);
    	double res = num * Math.pow(10, decimals);
    	res = Math.round(res);
    	res = res / Math.pow(10, decimals);
    	
    	return res;
    }
	private int getPaddingTop(double height){
		if (height > 0.75){
			return 3;
		}else if(height > 0.50){
			return 2;
		}else if (height > 0.3){
			return 1;
		}
		
		return 0;
	}
}
